// ctrl.h
//

#ifndef _CTRL_H_
#define _CTRL_H_

#include <pktlab.h>

#include <stdbool.h>

//
// EXPORTED TYPE DEFINITIONS
//

enum ctrl_state {
	ST_INIT        = 0,
	ST_HANDSHAKING = 1,
	ST_ESTABLISHED = 2,
	ST_ERROR       = -1
};

enum ctrl_type {
	NEITHER_TYPE = 0,
	TCP_TYPE     = 1,
	SSL_TYPE     = 2,
};

struct pktctrl_obj {
	int sockfd;
	enum ctrl_state state;
	enum ctrl_type type;
	struct ssl_aux * saux;
	struct pktlab_reader * reader;
	struct pktlab_writer * writer;
	pktlab_read_t readfunc;
	pktlab_write_t writefunc;
	void * readaux;
	void * writeaux;
	bool hs_need_read;
	bool hs_need_write;
	bool read_need_write;
	bool write_need_read;
};

#endif