// util_openssl.h
//

#ifndef _UTIL_OPENSSL_H_
#define _UTIL_OPENSSL_H_

#include <stdbool.h>

//
// EXPORTED GLOBAL VARIABLE DECLARATIONS
//

// Steps for adding a new OID
//  1. Define the OID string in pktlab.h
//  2. Add a new int variable declaration here for storing the openssl NID
//  3. Add the definition of the NID variable in util_openssl.c
//  4. Add a new entry to the map in init_pktlab_nid in util_openssl.c for initialization
// And voila! We have the new OID set for other code to use.

extern bool _nid_defined;

// pktlab extension OIDs
extern int _nid_cert_type;
extern int _nid_cert_desc;
extern int _nid_filter_digests;
extern int _nid_monitor_digests;
extern int _nid_priority;
extern int _nid_del_type;

//
// EXPORTED FUNCTION DECLARATION
//

extern int try_init_openssl(void);
extern void error_debug_msg(const char * func_name);

#endif