#ifndef _XDESCRPOOL_H_
#define _XDESCRPOOL_H_

#include <pktlab.h>

//
// EXPORTED TYPE DEFINITIONS
//

struct xdescr_node {
    struct xdescr_node *next;
    char *xdescr;
    uint_fast32_t xdescrlen;
    pktlab_time_t yield_hint;
    pktlab_time_t expire;
    char controller_addr[256];
    char snikey[64];
    uint32_t exp_priority;
};

//
// EXPORTED FUNCTION DECLARATIONS
//

extern struct xdescr_node *xdescrnode_construct(const char *xdescrbuf,
                                                uint_fast32_t xdescrlen);
extern void xdescrnode_destroy(struct xdescr_node *node);
// add experiment (doesn't check for duplicates)
extern int xdescrpool_push(struct xdescr_node *node);

// remove experiment
extern int xdescrpool_remove(struct xdescr_node *node);

// get experiment (highest priority)
// goal: get the experiment with highest priority that hasn't expired yet
// also return the earliest yield-hint of higher priority exp
extern struct xdescr_node *xdescrpool_get(pktlab_time_t *yield_hint);

//
// XDESCR UTILITIES
//

extern int get_xdescr_spec(const char * spec, char ** xdescr);

#endif